c                                                           c
c   Program splits pdb_file generated by CAYANA2 into       c
c   set of pdb_files in CNS format.                         c
c                                                           c
c    needs  atomtransC.tbl                                  c
c                                                           c
c    Written by Alexander Lemak, (2005)                     c 
c                                                           c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

        implicit real*8(a-h,o-z)

        character*4  at1, at2, begl, prefx 
        character*3 resnm 
	character fl_cyan *20,fnm0*8,fnm1*10,fnm2*11,fnm3*12,ezap*28 
        character*1 a1, a2, a3, a4
	  
	 character*3 restbl(400)
	 character*4 atmtbl(5,400)	 
	 	
	 COMMON /tbl/ restbl, atmtbl, ntbl	 
c

        call GETARG(1,fl_cyan)    !file with Cyana pdb file
        open(11, file=fl_cyan)

        
	CALL GETARG(2,prefx)      ! prefix of CNS_pdb filenames	

ciiiiiiiiiii
          ntbl = 375
c
          itbl1 = 2
	  
	  itbl2 = 3	  
	  
c
          open(33,file='atomtransC.tbl')
	  do i=1,ntbl
	  print *, i
	  read(33,'(A3,2X,4(A4,1X),A4)') 
     +	           restbl(i),(atmtbl(kk,i),kk=1,5)
           
c           print '(A3,2X,4(A4,1X),A4)', 
c     +	           restbl(i),(atmtbl(kk,i),kk=1,5)
          enddo	
ciiiiiiiiiii
c
	
	fnm0 = prefx//'.lst'
	open(14,file=fnm0)       ! file with list of filenames

c
c  number of atoms
c
          DO iz=1,999999
          read(11,'(A4)',err=1,end=1) begl
	  if( begl .eq. 'MODE' ) natom=0
	  if( begl .eq. 'TER ' ) goto 1
	  if( begl .eq. 'ENDM' ) goto 1	      
	  if( begl .eq. 'ATOM' ) natom = natom + 1	  
          ENDDO
 1        print *,'number of atoms in protein ', natom 
c
c
          fjnk1 = 1.0
	  fjnk2 = 0.0

          rewind 11
          nfile = 0
          DO iz=1,999999
          read(11,'(A4)',err=2,end=2) begl
	  if( begl .eq. 'MODE' ) then
             
             nfile = nfile + 1
                                    !  file name	     
            ifl = nfile
	    nfk1 = int(real(ifl)/100.0)
	    IF( nfk1 .eq. 0 ) THEN
	  
              nfk  = int(real(ifl)/10.0)	  
	      if( nfk .eq. 0 ) then
	  
                 fnm1 = prefx//'_'//char(48+ifl)//'.pdb'
                 open(10, file=fnm1 )
                 print *,nfile,'  ',fnm1
                 write(14,'(A10)') fnm1
                            
              else
	  
                 fnm2 = prefx//'_'//char(48+nfk)//
     +	                char(48+ifl-nfk*10)//'.pdb'
	         open(10, file=fnm2 )
                 print *,ifl,'  ',fnm2
                 write(14,'(A11)') fnm2
	      	     	     
	      endif 
	  
	    ELSE
	  
	       ifl1 = ifl - nfk1*100
               nfk  = int(real(ifl1)/10.0)             
               fnm3 = prefx//'_'//char(48+nfk1)//char(48+nfk)//
     +	            char(48+ifl1-nfk*10)//'.pdb'
	       open(10, file=fnm3,err=1 )
	       print *,ifl,'  ',fnm3	     
               write(14,'(A12)') fnm3
	     
            ENDIF
                                    !  file name	    	     
c	     
	     
	     rewind 10
	     write(10,'(A20)') 'REMARK VERSION     1'	     
	     
             do ia=1,natom
	        read(11,100) begl, iat, at1, resnm, ir, ezap   

                if( at1(1:1) .eq. ' ' ) then
                a2 = at1(2:2)             
                a3 = at1(3:3) 
                a4 = at1(4:4) 
                at1 = a2//a3//a4//' '
                if( at1(1:1) .eq. ' ' )  at1 = a3//a4//'  '
                if( at1(1:1) .eq. ' ' )  at1 = a4//'   '
                endif
	    
	        call atom_trans(itbl1,at1,itbl2,at2,resnm)	  
	          
		write(10,101)  begl,iat,at2,resnm,ir,ezap,fjnk1,fjnk2  
	           
	     enddo 
	     write(10,'(A4)') 'END '
	     close(10) 
             
	     read(11,'(A4)') begl
	     if( begl .ne. 'TER ' ) print *,'problem with structure ' 
	      
	  endif
          ENDDO
 2        print *,'number of structures ', nfile 	  
c
 100      format(A4,2X,I5,1X,A4,1X,A3,2X,I4,A28)
 101      format(A4,2X,I5,1X,A4,1X,A3,2X,I4,A28,2F6.2)
c
        STOP
	END  
c----------------------------------------------------------------------
c
        SUBROUTINE  atom_trans(itb1,atm1,itb2,atm2,resnm)
c
c  itb =  1   -  BMRB
c         2   -  PDB
c         3   -  CNS
c         4   -  XPLOR  
c         5   -  CAYANA2
	
	character*4 atm1, atm2 
	character*3 resnm
	character*3 restbl(400)
        character*4 atmtbl(5,400)	 
	
        COMMON /tbl/ restbl, atmtbl, ntbl
c
c atmom names  vyrovn sprava
c
c
c                                     ! translation
	   ktbl = 0
	   do  k=1,ntbl
             if( ( restbl(k) .eq. resnm ) .AND.
     +           ( atmtbl(itb1,k) .eq. atm1 ) ) ktbl = k	        
           enddo
	   if( ktbl .eq. 0 ) then
	     print *,'no translation for ',resnm,' ',atm1,'  ',itb1
	   else
	     atm2 = atmtbl(itb2,ktbl)
	   endif
c
         RETURN
	 END 

