c                                                           c
c   Program splits pdb_file generated by CAYANA2 into       c
c   set of pdb_files in CNS format.                         c
c                                                           c
c    needs  atomtransC.tbl                                  c
c                                                           c
c    Written by Alexander Lemak, (2005)                     c 
c                                                           c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

        implicit real*8(a-h,o-z)

        character*4  at1, at2, begl 
	character*8  prefx 
        character*3 resnm 
	character fl_cyan *20,fnm0*8,fnm1*14,fnm2*15,fnm3*12,ezap*28,
     +             fbeg*14, flist*12	 
        character*1 a1, a2, a3, a4
	  
	 character*3 restbl(400)
	 character*4 atmtbl(5,400)	 
	 	
	 COMMON /tbl/ restbl, atmtbl, ntbl	 
c

         CALL GETARG(1,prefx)      ! prefix of CNS_pdb filenames	

c
c  number of atoms
c
          natom = 0

          fnm1 = prefx//'_1'//'.pdb'
          open(11, file=fnm1, err=1 )
          print *,fnm1

          DO iz=1,999999
          read(11,'(A4)',err=1,end=1) begl
	  if( begl .eq. 'TER ' ) goto 1
          if( begl .eq. 'ATOM' ) natom = natom + 1	  
          ENDDO
 1        print *,'number of atoms in protein ', natom 
c          natom = natom - 2
c	  natoml = natom - 1
          close (11)
c
c
          fnm2 = prefx//'_al.pdb'
	  flist = prefx//'.lst' 
          open(14, file=fnm2 )
          open(17, file=flist )	  
c
c

          fjnk1 = 1.0
	  fjnk2 = 0.0

       nfile = 0
       DO ifl = 1,99

          nfk = int(real(ifl)/10.0)
	  if( nfk .eq. 0 ) then
	  
             fnm1 = prefx//'_'//char(48+ifl)//'.pdb'
             open(11, file=fnm1, err=2 )
	     print *,ifl,'  ',fnm1
             write(17,'(A14)') fnm1
	     
          else
	  
            fnm2 = prefx//'_'//char(48+nfk)//
     +	           char(48+ifl-nfk*10)//'.pdb'
	    open(11, file=fnm2,err=2 )
	     print *,ifl,'  ',fnm2
	     
             write(17,'(A15)') fnm2
	     	     
	  endif 

          nfile = nfile + 1
          rewind 11
          
          DO iz=1,999999
          read(11,'(A14)',err=2,end=2) fbeg
          if( fbeg .eq. 'REMARK VERSION' ) then
	  
             write(14,'(A10,I4)') 'MODEL     ', nfile	  
             iai = 0 
	     do 20 ia=1,natom
	        read(11,100) begl, iat, at1, resnm, ir, ezap   

	        iai = iai + 1  
		
                if( at1 .eq. ' ZN ' ) then 
		     resnm=' ZN'
                     at1 = 'ZN  '
        write(14,103) 'HETATM',iai,at1,resnm,'A',ir,ezap,fjnk1,fjnk2 
	
	        else 
        write(14,102)  begl,iai,at1,resnm,'A',ir,ezap,fjnk1,fjnk2 			
		
		endif     
 
	       
	       
	        if( at1 .eq. ' OT2' ) then
                        iai = iai + 1 
	             write(14,102) 'TER ', iai, '    ',resnm,'A',ir	   
		endif          		
		
  
	           
  20	     enddo 
             iai = iai + 1 
c	     write(14,101) 'TER ', iai, '    ',resnm,ir
	     write(14,'(A6)') 'ENDMDL'
             goto 3
	      	      
	  endif
          ENDDO
	  
 3	  close(11)
	  
	  ENDDO 
	  
 2        print *,'number of structures ', nfile 	  
c
 100      format(A4,2X,I5,1X,A4,1X,A3,2X,I4,A28)
 101      format(A4,2X,I5,1X,A4,1X,A3,2X,I4,A28,2F6.2)
 102      format(A4,2X,I5,1X,A4,1X,A3,1X,A1,I4,A28,2F6.2) 
 103      format(A6,I5,1X,A4,1X,A3,1X,A1,I4,A28,2F6.2) 
c
        STOP
	END  
c----------------------------------------------------------------------
c
        SUBROUTINE  atom_trans(itb1,atm1,itb2,atm2,resnm)
c
c  itb =  1   -  BMRB
c         2   -  PDB
c         3   -  CNS
c         4   -  XPLOR  
c         5   -  CAYANA2
	
	character*4 atm1, atm2 
	character*3 resnm
	character*3 restbl(400)
        character*4 atmtbl(5,400)	 
	
        COMMON /tbl/ restbl, atmtbl, ntbl
c
c atmom names  vyrovn sprava
c
c
c                                     ! translation
	   ktbl = 0
	   do  k=1,ntbl
             if( ( restbl(k) .eq. resnm ) .AND.
     +           ( atmtbl(itb1,k) .eq. atm1 ) ) ktbl = k	        
           enddo
	   if( ktbl .eq. 0 ) then
	     print *,'no translation for ',resnm,' ',atm1,'  ',itb1
	   else
	     atm2 = atmtbl(itb2,ktbl)
	   endif
c
         RETURN
	 END 

